float angle = 0.95;
float branchScale = 0.75;
float length = 120;
float minL = 5;

boolean randomize = false;
PRNG prng;
void setup()
{
  
  size( 600,600 );
  prng = new PRNG();
  
}
void draw()
{
  background( 0 );
  noStroke();
  fill( 0xFF );
  
  angle = ( mouseY / 600.0 ) * PI;//( .5 + sin( millis() * 0.001 ) * .5 ) * PI;
  
  translate( width * .5, height );
  
  prng.seed( int( mouseX ) );
  drawBranch( length, 0);
}


void mousePressed()
{
  
  randomize = !randomize ? true : false;

}

void drawBranch( float length, float direction )
{
  if( !randomize )
  {
    
    pushMatrix();
    
    rotate( angle * direction );
    
    rect(-length / 20, 0, length / 10, -length );
    
    if ( length > minL ) 
    {
      
      translate( 0, -length );
      
      drawBranch(length * branchScale, -1 );
      drawBranch(length * branchScale,  1 );
      
    }
    
    popMatrix();
    
  }
  else
  {
    
    pushMatrix();
    
    //randomize angle
    float a = prng.random() * angle;
    rotate( a * direction );
    
    
    rect(-length / 20, 0, length / 10, -length );
    
    if ( length > minL ) 
    {
      
      translate( 0, -length );
      drawBranch( length * ( prng.random() * .2 + .9 ) * branchScale, -1);
      drawBranch( length * ( prng.random() * .2 + .9 ) * branchScale, 1);
      
    }
    
    popMatrix();
    
  }
    
}
